package cn.com.qmth.examcloud.core.oe.task.provider;


import cn.com.qmth.examcloud.core.oe.task.api.ExamCaptureCloudService;
import cn.com.qmth.examcloud.core.oe.task.api.request.ExistUnhandledCaptureQueueReq;
import cn.com.qmth.examcloud.core.oe.task.api.request.SaveExamCaptureSyncCompareResultReq;
import cn.com.qmth.examcloud.core.oe.task.api.request.UpdateExamCaptureQueuePriorityReq;
import cn.com.qmth.examcloud.core.oe.task.api.response.ExistUnhandledCaptureQueueResp;
import cn.com.qmth.examcloud.core.oe.task.dao.ExamCaptureQueueRepo;
import cn.com.qmth.examcloud.core.oe.task.service.ExamSyncCaptureService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description
 * @Author lideyin
 * @Date 2019/10/12 11:01
 * @Version 1.0
 */
@RestController
@RequestMapping("${$rmp.cloud.oe.student.face}/examCapture")
public class ExamCaptureCloudServiceProvider extends ControllerSupport
        implements ExamCaptureCloudService {

    @Autowired
    private ExamSyncCaptureService examSyncCaptureService;

    @Autowired
    private ExamCaptureQueueRepo examCaptureQueueRepo;

    @Override
    @ApiOperation(value = "保存抓拍照片的同步比较结果")
    @PostMapping("/saveExamCaptureSyncCompareResult")
    public void saveExamCaptureSyncCompareResult(@RequestBody SaveExamCaptureSyncCompareResultReq request) {
        examSyncCaptureService.saveExamCaptureSyncCompareResult(request.getStudentId(),
                request.getExamRecordDataId());
    }

    /**
     * @param req 更新优先级请求参数
     * @description 更新考试抓拍照片在队列优中的先级
     * @date 2019/7/31 16:46
     * @author lideyin
     */
    @Override
    @ApiOperation(value = "更新考试抓拍照片在队列优中的先级")
    @PostMapping("/updateExamCaptureQueuePriority")
    public void updateExamCaptureQueuePriority(@RequestBody UpdateExamCaptureQueuePriorityReq req) {
        examCaptureQueueRepo.updateExamCaptureQueuePriority(req.getPriority(), req.getExamRecordDataId());
    }

    /**
     * 是否存在未处理的图片抓拍队列(处理完成的队列数据都会清理掉)
     *
     * @param req
     * @return
     */
    @Override
    @ApiOperation(value = "是否存在未处理的图片抓拍队列")
    @PostMapping("/existsUnhandledCaptureQueue")
    public ExistUnhandledCaptureQueueResp existsUnhandledCaptureQueue(@RequestBody ExistUnhandledCaptureQueueReq req) {
        ExistUnhandledCaptureQueueResp resp = new ExistUnhandledCaptureQueueResp();
        resp.setExist(examCaptureQueueRepo.existsUnhandledByExamRecordDataId(req.getExamRecordDataId()) != null);
        return resp;
    }

}
